//cutscenes00

string cutscene[30];
string intro_cutscene;

var rank;
var user;

bmap subtitle01_tga = <subtitle01.tga>;
bmap widescreen_pcx = <widescreen.pcx>;

entity* asteroid_ent;

entity* enemy_ship_ent;
entity* enemy_warship_i1;
entity* enemy_warship_i2;

//bmap engine_flare_pcx = <engine_flare.pcx>;	//engine flare effect bitmap

string tv_01_mdl = <tv_01.mdl>;			//tv model w/lucy
string big_alien_mdl = <berzerka.mdl>;	//big alien
string suit_mdl = <inmate.mdl>;			//human

string enemy_mdl = <starship01.mdl>;	//starship for cutscene
string enemy02_mdl = <enemy_02a.mdl>;	//warship for cutscene

var on_stage_pos[3] = 20,0, 9120;	//tv position for cutscene
var on_stage_pos1[3] = 20,50,9120;	//big_alien pos for cutscene
var on_stage_pos2[3] = 20,-40,9060;	//suited human for cutscen

var enemy_start[3] = -2000,0,-25;	//spaceship start pos
var enemy_start2[3] = -2075, -50, -55;	//warship1 start pos
var enemy_start3[3] = -2075, 50, -55;	//warship2 start pos

string stage_intro_wmb = <stage_intro.wmb>;	//stage_intro

entity* stage_intro_ent;
entity* big_alien_ent;
entity* tv_ent;
entity* suit_ent;
var stage_pos[3] = 0,0,9010;						//stage position
var cassini_vol = 4;



panel subtitle01
{
	bmap = subtitle01_tga;
	pos_x = 1;
	pos_y =900;
	layer = 0;
	
}

panel widescreen_top
{
	bmap = widescreen_pcx;
	pos_x = 0;
	pos_y = -160;
	layer = 10;
}

panel widescreen_bot
{
	bmap = widescreen_pcx;
	pos_x = 0;
	pos_y = 1119;
	layer = 10;
}

view cutscene_cam
{
	layer = 5;
	x = -2000;
	y = 0;
	z = 0;
	tilt = 0;
	pan = 60;
}

view cutscene_cam2
{
	layer = 5;
	x = -500;
	y = 0;
	z = 9300;
	pan = 135;
	clip_far = 10000;
	tilt = -25;
}

view cutscene_cam3
{
	layer = 5;
	x = 40;
	y = -200;
	z = 9100;
	pan = 99;
}


function set_widescreen()
{
	if(video_mode == 9)
	{
		widescreen_top.pos_y = -100;
		widescreen_bot.pos_y = 900;
		widescreen_top.visible = on;
		widescreen_bot.visible = on;
	}
	
	
}

function set_subtitles()
{
	if(video_mode == 9)
	{
		subtitle01.pos_y = 760;
	}
	
}

function end_cutscene()
{
	widescreen_top.visible = off;
	widescreen_bot.visible = off;
	set_panel_variables();
	wait(1);
	init_gamecounter();
	ent_remove(enemy_ship_ent);
	ent_remove(enemy_warship_i1);
	ent_remove(enemy_warship_i2);
	ent_remove(suit_ent);
	ent_remove(tv_ent);
	ent_remove(big_alien_ent);
	cutscene_on = 0;
}

//function cutscene_start(cutscene)
//{
//	on_camera_fade_in(x,y,z,pan,tilt,roll);
//}
//

function start_cassini()
{
	cassini_handle = snd_play(cassini_division_wav, 60, 0);
//	while(cassini_vol < 100)
//	{
//		cassini_vol += 1* time;
//	}

}

function start_wardrums()
{
	wait(95);
	wardrums_handle = snd_loop(wardrums_wav, 50, 0);
}

function start_intro1()
{
	//wait(125);
	intro_01_handle = snd_play(intro_01_wav, 100,0);
}

function play_ricky()
{
	wait(60);
	ricky_wav_handle = snd_play(ricky_wav, 30,0);
}

function start_intro2()
{
	wait(120);
	intro_02_handle = snd_play(intro_02_wav, 100,0);
}

action big_alien
{
	big_alien_ent = me;
	my.scale_x = 3;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	my.pan = -90;
	while(1)
	{
			ent_cycle("attack", my.skill48); // play the "attack" frames animation
			//my.skill48 += 4 * time; // "attack" animation speed - but removed for cutscene
			my.skill48 %= 30; // only on frame
			vec_set (temp, my.x); // trace 10,000 quants below the model
			temp.z -= 10000;
			trace_mode = ignore_me + ignore_passable + use_box;
			temp.z = -trace (my.x, temp); // and adjust its height accordingly, placing its feet on the ground	
			wait(1);	
	}
}

action suit_human
{
	suit_ent = me;
	my.scale_x = 0.5;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	my.pan = 90;
	while(1)
	{
			ent_cycle("idle", my.skill48); // play the "stand" frames animation
			my.skill48 += 4 * time; // "stand" animation speed
			my.skill48 %= 100; // loop animation		
			wait(1);	
	}
}

action television
{
	tv_ent = me;
	my.scale_x = 1;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	my.pan = -90;
}

function engine_loop()
{

    	my.alpha -= 15 *time;
    	my.size -= 1 * time;
			
			
		if(my.size <0)
		{
			my.lifespan = 0;
		}
    	if(my.alpha < 0) 
    	{ 
    	my.alpha = 0; 
    	my.lifespan = 0; 
    	}

}
var engine_temp_1[3];
	var engine_temp_2[3];
	
function engine_effect()
{
	my.blue = 128;
   my.green = 128;
   my.red = 128;
   my.bmap = engine_flare_pcx; //the effect bitmap
   my.vel_x = random( -0.5);
   //my.vel_y = random( 0.5 ) - 0.250 ;
   //my.vel_z = random( 0.5 );
   my.size = 4;
   my.alpha = 70;
   my.gravity = off;
   //my.streak = on;
   my.flare = on;
   my.bright = on;
   //my.beam = on;
   my.move = on;
   my.transparent = on;
   my.function = engine_loop;
//   while(1)
//   {
//		my.x = vec_for_vertex(engine_temp_1, you,80);
//		my.x = vec_for_vertex(engine_temp_2, you,75);
//		
//		wait(1);
//   	
//}
}

function engine_effect2()
{
	my.blue = 128;
   my.green = 128;
   my.red = 128;
   my.bmap = engine_flare_pcx; //the effect bitmap
   my.vel_x = random( -0.5);
   //my.vel_y = random( 0.5 ) - 0.250 ;
   //my.vel_z = random( 0.5 );
   my.size = 10;
   my.alpha = 70;
   my.gravity = off;
   //my.streak = on;
   my.flare = on;
   my.bright = on;
   //my.beam = on;
   my.move = on;
   my.transparent = on;
   my.function = engine_loop;
//   while(1)
//   {
//		my.x = vec_for_vertex(engine_temp_1, you,80);
//		my.x = vec_for_vertex(engine_temp_2, you,75);
//		
//		wait(1);
//   	
//}
}

action stage_intro_act
{
	stage_intro_ent = me;
	my.light = on;
	
}

action enemy_ship
{
	enemy_ship_ent = me;
	var var_particle;
	my.invisible = off;
	my.scale_x = 0.15;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	my.metal = on;
	vec_for_vertex(engine_temp_1, me,80);
	vec_for_vertex(engine_temp_2, me,75);
	
	effect(engine_effect, 100,engine_temp_1, normal);
	effect(engine_effect, 100,engine_temp_2, normal);
	
//	while(1)
//	{
		
	while(cutscene_cam < -1900)
	
	{
	vec_for_vertex(engine_temp_1, me,80);
	vec_for_vertex(engine_temp_2, me,75);
		
		var_particle = 15;
		effect(engine_effect,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect,max(1,var_particle*time),engine_temp_2,normal);		
		
		wait(1);
	}
	while(my.x < - 1200)
	{
	vec_for_vertex(engine_temp_1, me,80);
	vec_for_vertex(engine_temp_2, me,75);
		
		var_particle = 15;
		effect(engine_effect,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect,max(1,var_particle*time),engine_temp_2,normal);			
		
		my.x += 12.25 * time;
		wait(1);
	}
	while(my.z < 60)
	{
	vec_for_vertex(engine_temp_1, me,80);
	vec_for_vertex(engine_temp_2, me,75);
		
		var_particle = 15;
		effect(engine_effect,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect,max(1,var_particle*time),engine_temp_2,normal);		
		
		my.z += 1 * time;
		my.x += 5 * time;
		my.tilt += 0.05 * time;
		my.roll += 0.09 * time;
		wait(1);
	}
	while(my.z > 0)
	{
	vec_for_vertex(engine_temp_1, me,80);
	vec_for_vertex(engine_temp_2, me,75);
		
		var_particle = 15;
		effect(engine_effect,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect,max(1,var_particle*time),engine_temp_2,normal);			
		
		my.x += 7.5 * time;
		my.z -= 1* time;
		my.tilt -= 0.05 * time;
		my.roll -= 0.09 * time;
		wait(1);
	}
	while(my.x < -280)
	{
	vec_for_vertex(engine_temp_1, me,80);
	vec_for_vertex(engine_temp_2, me,75);
		
		var_particle = 2;
		effect(engine_effect,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect,max(1,var_particle*time),engine_temp_2,normal);		
		
		my.x += 4 * time;
		wait(1);
	}
//	wait(1);
//		
//	}
	
}

action enemy_warship
{
	enemy_warship_i1 = me;
	var var_particle;
	my.invisible = off;
	my.overlay = on;
	my.metal = on;
	my.scale_x = 0.75;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	my.pan = 180;
	while(cutscene_cam < -1900)
	
	{
		wait(1);
	}
	while(my.x < - 1200)
	{
		vec_for_vertex(engine_temp_1, me,5);
		vec_for_vertex(engine_temp_2, me,51);
		
		var_particle = 2;
		effect(engine_effect2,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect2,max(1,var_particle*time),engine_temp_2,normal);		
		my.x += 12.45 * time;
		wait(1);
	}
	while(my.z < 60)
	{
		vec_for_vertex(engine_temp_1, me,5);
		vec_for_vertex(engine_temp_2, me,51);
		
		var_particle = 2;
		effect(engine_effect2,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect2,max(1,var_particle*time),engine_temp_2,normal);
		my.z += 1 * time;
		my.x += 7 * time;
		my.tilt += 0.05 * time;
		my.roll += 0.09 * time;
		wait(1);
	}
	while(my.z > 0 && my.x <= -250)
	{	
	vec_for_vertex(engine_temp_1, me,5);
		vec_for_vertex(engine_temp_2, me,51);
		
		var_particle = 2;
		effect(engine_effect2,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect2,max(1,var_particle*time),engine_temp_2,normal);
		my.x += 7.5 * time;
		my.z -= 1* time;
		my.tilt -= 0.05 * time;
		my.roll -= 0.09 * time;
		wait(1);
	}
	while(1)
	{
		vec_for_vertex(engine_temp_1, me,5);
		vec_for_vertex(engine_temp_2, me,51);
		
		var_particle = 15;
		effect(engine_effect,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect,max(1,var_particle*time),engine_temp_2,normal);
		wait(1);
	}
//	while(my.x < -300)
//	{
//		my.x += 4 * time;
//		wait(1);
//	}
//	while(my.x == -700)
//	{
//		wait(1);
//	}
}

action enemy_warship2
{
	enemy_warship_i2 = me;
	var var_particle;
	my.invisible = off;
	my.overlay = on;
	my.metal = on;
	my.scale_x = 0.75;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	my.pan = 180;
	while(cutscene_cam < -1900)
	
	{
		wait(1);
	}
	while(my.x < - 1200)
	{
		vec_for_vertex(engine_temp_1, me,5);
		vec_for_vertex(engine_temp_2, me,51);
		
		var_particle = 2;
		effect(engine_effect2,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect2,max(1,var_particle*time),engine_temp_2,normal);		
		my.x += 12.45 * time;
		wait(1);
	}
	while(my.z < 60)
	{
		vec_for_vertex(engine_temp_1, me,5);
		vec_for_vertex(engine_temp_2, me,51);
		
		var_particle = 2;
		effect(engine_effect2,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect2,max(1,var_particle*time),engine_temp_2,normal);
		my.z += 1 * time;
		my.x += 7 * time;
		my.tilt += 0.05 * time;
		my.roll += 0.09 * time;
		wait(1);
	}
	while(my.z > 0 && my.x <= -250)
	{	
	vec_for_vertex(engine_temp_1, me,5);
		vec_for_vertex(engine_temp_2, me,51);
		
		var_particle = 2;
		effect(engine_effect2,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect2,max(1,var_particle*time),engine_temp_2,normal);
		my.x += 7.5 * time;
		my.z -= 1* time;
		my.tilt -= 0.05 * time;
		my.roll -= 0.09 * time;
		wait(1);
	}
	while(1)
	{
		vec_for_vertex(engine_temp_1, me,5);
		vec_for_vertex(engine_temp_2, me,51);
		
		var_particle = 15;
		effect(engine_effect,max(1,var_particle*time),engine_temp_1,normal);		
		effect(engine_effect,max(1,var_particle*time),engine_temp_2,normal);
		wait(1);
	}
//	while(my.x < -300)
//	{
//		my.x += 4 * time;
//		wait(1);
//	}
//	while(my.x == -700)
//	{
//		wait(1);
//	}
}



function play_cutscene(cutscene,rank,user)
{
	//var d3d_lightres = on;
	var fps_max = 20;
	var fps_lock = on;
	cutscene_on = 1;
	mouse_mode = 0;
	planet_cam.visible = off;
	turn_screen.visible = off;
	//wait(2);
	if(rank == 1)
	{
		set_subtitles();
		set_widescreen();
		camera.visible = off;
		//asteroid_ent.invisible = on;
		cutscene_cam.visible = on;
		cutscene_cam.clip_far = 4000;
		//turn_off_else();
		
		Clib_Panel_Fade(subtitle01,0,100,2);
//		while(enemy_mdl.x < 250)
//		{
//			
//		}
		while(cutscene_cam.pan > 0)
		{
			cutscene_cam.pan -= 1 * time;
			wait(1);
			
		}
			ent_create(enemy_mdl, enemy_start,enemy_ship);
			ent_create(enemy02_mdl, enemy_start2,enemy_warship);
			ent_create(enemy02_mdl, enemy_start3,enemy_warship2);
			
		
		Clib_Panel_Fade(subtitle01,100,0,1);
		
//		while(cutscene_cam.y < 200)
//		{
//			cutscene_cam.y += 1 * time;
//		}
		//wait(20);
		start_wardrums();
		while(cutscene_cam.x < -1100)
		{
			//enemy_ship.x += 10.1 * time;
			
			cutscene_cam.x += 10 * time;
			wait(1);
		}
		while(cutscene_cam.y < 60)
		{
			cutscene_cam.z += 1 * time;
//			cutscene_cam.y += 1 * time;
			cutscene_cam.x += 4.5 * time;
			cutscene_cam.pan -= 0.5 * time;
			
			//cutscene_cam.roll -= 1* time;
			cutscene_cam.y += 1 * time;
				wait(1);
			}
			
			//cutscene_cam.x += 1 * time;
		}
		//start_cassini();
		//asteroid_ent.invisible = off;
		while(cutscene_cam.y > 0)
		{
			cutscene_cam.y -= 1 * time;
			cutscene_cam.x += 5 * time;
			cutscene_cam.z -= 1 * time;
			cutscene_cam.pan +=0.15;
			wait(1);
		}
		start_intro1();
		
		while(cutscene_cam.x < -300)
		{
			cutscene_cam.x += 5 * time;
			while(cutscene_cam.z < 25)
			{
				cutscene_cam.z += 1 * time;
				cutscene_cam.pan -= 1 * time;
				wait(1);
				
			}
				cutscene_cam.tilt -= 0.60 * time;
			
			wait(1);
		}
	//	wait(360);
	//	beep();
	ent_create(stage_intro_wmb,stage_pos,stage_intro_act);
	ent_create(tv_01_mdl, on_stage_pos, television);
	//camera.visible = on;
	ent_create(big_alien_mdl, on_stage_pos1, big_alien);
	ent_create(suit_mdl,on_stage_pos2, suit_human);
	wait(1);
	//cutscene_start(cutscene)
	cutscene_cam2.visible = on;
	cutscene_cam.visible = off;
	while(cutscene_cam2.pan > 0 )
		{
			cutscene_cam2.x += 1 * time;
			cutscene_cam2.pan -= 1.75 * time;
			wait(1);
		}
	//wait(360);
	//set_panel_variables();
	//init_music();
	play_ricky();
	cutscene_cam2.visible = off;
	cutscene_cam3.visible = on;
	start_intro2();
	wait(400);
	while(cutscene_cam3.z < 9180)
	{
		cutscene_cam3.z += 1 * time;
		cutscene_cam3.pan += 0.5 * time;
		wait(1);
	}
	cutscene_cam3.visible = off;
	
	camera.visible = on;
	planet_cam.visible = on;
	end_cutscene();
	
	}
