//warship

string projectile_mdl = <pbullet.mdl>;
sound rocketflying_wav = <engine.wav>;
sound pexplo_wav = <explosion.wav>;

bmap core1_tga = <core1.tga>;
bmap core2_tga = <core2.tga>;

string explosion_pcx = <explo+20.pcx>;


function core_fade()
{
	if (my.alpha > 50)
	{
		my.size += 0.2 * time;
	}
	else
	{
		my.size -= 0.2 * time;
	}
	my.alpha -= 3 * time;
	if (my.alpha < 0) 
	{ 
		my.lifespan = 0; 
	}
}


function explosion_core()
{
	if (random(1) > 0.5)
	{
		my.bmap = core1_tga;
	}
	else
	{
		my.bmap = core2_tga;
	}	
	my.transparent = on;
	my.passable = on;
	my.flare = on;
	my.bright = on;
	my.size = random(1) + 1;
	my.alpha = 100;
	my.function = core_fade;
}

function explosion_sprite2()
{
	my.passable = on;
	my.facing = on;
	my.bright = on;
	my.flare = on;
	my.ambient = 100;
	my.red = 255;
	//my.lightrange = 100;
	my.passable = on;
	while (my.frame < 20)
	{
		my.frame += 1 * time;
		my.scale_x += 0.1 * time;
		my.scale_y = my.scale_x;
		//my.lightrange = 300 - random(100);
		wait(1);
	}
	ent_remove(my);
}

function warship_destroy()
{
	warship_ent.skill30 = 0;
}

function projectile_explodes()
{
	my.event = null;
	sleep (0.1);
	my.passable = on;
	my.invisible = on;
	ent_playsound (my, pexplo_wav, 2000); // the projectile hits something
	//effect (explosion_core, 10 + random(10), my.x, nullvector);
	sleep (0.1);
	ent_create (explosion_pcx, my.x, explosion_sprite2);
	sleep (0.1);
//	ent_create (explosion_pcx, my.x, explosion_sprite2);
//	sleep (0.1);
//	ent_create (explosion_pcx, my.x, explosion_sprite2);
//	sleep (0.1);
//	ent_create (explosion_pcx, my.x, explosion_sprite2);
//	sleep (0.1);
//	ent_create (explosion_pcx, my.x, explosion_sprite2);
//	sleep (0.1);
//	ent_create (explosion_pcx, my.x, explosion_sprite2);	
}

function move_projectile()
{
	my.scale_x = 0.1;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	
	//c_setminmax(me);
	
	my.skill47 = 123; // to identify a bullet fired by the alien gunner
	
	my.skill31 = 7;
	my.pan = you.pan; // the bullet and the weapon have the same pan
	my.tilt = you.tilt; // and tilt angle
	my.enable_entity = on; // the bullet is sensitive to other entities
	my.enable_impact = on;
	my.enable_block = on; // and to level blocks
	my.event = projectile_explodes;
	my.ambient = 100;
//	my.light = on;
//	my.lightred = 250;
//	my.lightgreen = 150;
//	my.lightblue = 55;
	while (my.passable == off)
	{
		my.skill41 = (my.skill31 + your.skill31) * time;		
		
		//my.skill1 = 100 * time; // bullet speed
		my.skill2 = 0;
		my.skill3 = 0;
		move_mode = ignore_you + ignore_passents + ignore_passable + ignore_sprites;
		//ent_playsound (my, rocketflying_wav, 3000);
		ent_move (my.skill41, nullvector);
		if(vec_dist(my.x,your.x) > 1000)
		{
			my.passable = on;
			my.invisible = on;
		}
		wait (1);
	}
}


function warship_events()
{	
	if(EVENT_TYPE == event_touch)
	{
		
	}

	if(EVENT_TYPE == event_release)
	{
		
	}
	if (EVENT_TYPE == event_rightclick)
	{

	}
	if(EVENT_TYPE == EVENT_Scan)
	{
	}
	if(EVENT_TYPE == EVENT_DETECT)
	{

		//set_detect(you);
		if(your.skill69 == 1)
		{
			my.skill76 = 1;								//im on red alert
			my.skill75 = handle(you);					//and i'm gonna shoot you
			
		}
		 

			
	}
	if(EVENT_TYPE == EVENT_SONAR)
	{

	}
}

function enemy_warship_func()
{
	warship_ent = me;
	var colors_pos[3];
	var my_distance;
	var my_centre[3];
	
	var my_distance;
	var my_orbit;
	
	var gun_pos[3];
	var gun_pos2[3];
	
	my.scale_x = 0.1;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	
	c_setminmax(me);

	
	my.parent_handle = handle(you);
	my.skill1 = your.skill1;
	my.skill2 = my.x;
	my.skill3 = my.y;
	my.skill4 = my.z;
	
	my.skill16 = 100; // orbit distance

	my_centre.x = your.skill2;
	my_centre.y = your.skill3;
	my_centre.z = your.skill4;
	my.skill30 = 100;			//my health
	my.skill31 = 4.5;			//my speed
	my.skill32 = 0.01;			//my agility
	my.skill33 = 500;			// my scan range
	my.skill34 = 10;			//my fuel range
	my.skill35 = 0;			//my.target_x
	my.skill36 = 0;			//my.angle_pan
	my.skill37 = 0;			//my.unit_scan
	my.skill38 = 1;			//i'm a warship
	my.skill39 = 200;			//my comm range
	my.flag1 = 0;				//selected y/n
	my.flag2 = 0;				//detected y/n
	my.flag6 = 0;				//moving y/n
	
	my.skill69 = 2;			//my team/colors
	
	my_orbit = random(360);
	my_distance = my.skill16;
	
	my.enable_entity = on;
	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.enable_sonar = on;
	my.event = warship_events;
	
	colors_pos.x = my.skill2;
	colors_pos.y = my.skill3;
	colors_pos.z = my.skill4 + 1;
	wait(1);
	you = ent_create(player_colors_pcx, colors_pos, player_colors_func);		//my colors
	you.parent_handle = handle(me);
	wait(1);
//	you = ent_create(move_ring_spr,my.x,move_ring);									//my move ring
//	you.parent_handle = handle(me);
	
	var scan_temp[3];
	var scan_source[3];
	var detect_temp;
	var engine_temp_1[3];
	var engine_temp_2[3];
	var engine_temp_3[3];
	var start_point[3];
	var move_point[3];
	var temp_ang[3];
	var my_distance_from;
	var trace_distance;
	
	var temp_target[3];
	
	if(my.skill69 == 2)			//i'm an enemy
	{
		my.x = my_centre.x - fcos(my_orbit,my_distance);
		my.y = my_centre.y - fsin(my_orbit,my_distance);

	}
	start_point.x = my.x;
	start_point.y = my.y;
	start_point.z = my.z;
	
//	
//	while(my.flag1 != 1)
//		{
//			wait(1);					//wait until i'm selected and my direction is not set
//		}
//	while(my.flag6 != 1)
//		{
//			wait(1);
//		}
	//while(me != null)
	while(my.detected == off)
	{
		wait(1);
	}
	while(my.skill30 > 0)
		{
			
//			if(my.detected == off)
//			{
//				my.invisible = on;
//			}
			my.skill2 = my.x;
			my.skill3 = my.y;
			my.skill4 = my.z;
			
			scan_temp.x = 360;
			scan_temp.y = 360;
			scan_temp.z = my.skill33;
			
			scan_source.x = my.x;
			scan_source.y = my.y;
			scan_source.z = my.z;
			//you = null;
				
			scan_entity(scan_source,scan_temp);
			//my.skill75 = handle(you);				//set my target
			
			
			my.skill41 = my.skill31 * time;
					
			if(my.skill76 == 1 && my.skill75 != 0)
			{
				you = null;
				you = ptr_for_handle(my.skill75);
				
				vec_set(temp, you.x); // rotate the me towards the player
				vec_sub(temp, my.x); 
				vec_to_angle(my.pan, temp);
				move_mode = IGNORE_ME + IGNORE_PASSABLE + GLIDE;
				move_friction = my.skill32;
				ent_move(my.skill41,nullvector);
				//ent_playsound (my, engine1_wav, 100);
				if(vec_dist(you.x, my.x) < 4)
				{
					my.skill41 -= 0.5;
				}
				if(vec_dist(you.x,my.x) > 4)
				{
					my.skill41 += 0.5;
				}
				if ((vec_dist (you.x, my.x) < 17000) && (total_frames % 100 == 1))
			{
				
				vec_set (temp_target, my.x);
				//temp.z += 150; // the alien uses its head position to "see" (trace) the player
				trace_mode = ignore_me + ignore_passable + use_box;
				trace_distance = trace (temp_target.x, you.x);
				if ((trace_distance > 6) && (trace_distance < 15000)) // fire only if the player is visible
				{
					vec_for_bone (gun_pos, my, "weapon1"); // fire from the first vertex of the gun
					vec_for_bone (gun_pos2, my, "weapon2");
					ent_create (projectile_mdl, gun_pos.x, move_projectile);
					ent_create (projectile_mdl, gun_pos2.x, move_projectile);
					
					ent_playsound(my,warship_wav,150);
				}
			}
			}
			my.skill76 = 0;		//set these back to zero so i don't misscall
			my.skill75 = 0;
			wait(1);
		}
		
		destroy_me(me);	
}




function build_warship()
{
	you = ent_next (NULL); // retrieve first entity
 	while (you != NULL) // repeat until there are no more entities
	{
		if(your.flag1 == 1 && energy > 850)
		{
			var create_point[3];
			energy -= 850;
			create_point.x = your.skill2 + 50;
			create_point.y = your.skill3;
			create_point.z = your.skill4;
			
			ent_create(warship_mdl,create_point,enemy_warship_func);
			menu01_play_select_snd();	
		}
		else
		{
			
		}
 		you = ent_next (you); // get next entity
 			
 	}

}
